##Einleitung
Der Roboter “Fridolin” ist einer der möglichen Roboter, die an der [BOT Challenge](http://smart-machines.hs-kl.de/projekte/bot-challenge/ "Smart Machines - Bot Challenge") der Hochschule Kaiserslautern teilnehmen können. Die BOT Challenge wird vom Arbeitskreis Smart Machines organisiert und findet jährlich am Campus Zweibrücken statt. Es gibt hier zwei verschieden Wettkampfstrecken, den Line Follower Parcours und den Maze Parcours. Der Fridolin kann beide Parcours bewältigen.


Im Rahmen des Faches Projektmanagement des Studiengangs Angewandte Informatik vom Sommersemester 2019 hat das Team “Die Bitschubser” die Abstraktionsschicht “Super Tolle Fridolin Utilities” (STFU) für den Roboter Fridolin unter der Aufsicht von Prof. Adrian Müller entwickelt. Ziel war es, eine Schnittstelle anzubieten, die es vereinfachen soll, den Fridolin zu programmieren.
Mitglieder der Bitschubser waren Eric Rauch, Markus Dauth, Kevin Staut, Dominik Schramm, Felix Mayer, David Kosta und Christian Huwer.


##Der Fridolin
Der [Fridolin](http://smart-machines.hs-kl.de/ressourcen-des-ak/fridolin/ "Smart Machines - Fridolin") ist ein programmierbarer Miniroboter. Entwickelt und hergestellt wurde er von Herrn Jürgen Edel am Standort Zweibrücken der Hochschule Kaiserslautern.
Er wird mit einem Arduino Nano in C++ programmiert und besitzt u.A. folgende Bestandteile
- Arduino Nano (Mikroprozessor)
- Akkupack 9,6 Volt
- 2 Antriebsmotoren
- Ultraschallsensor mit Servomotor
- LCD-Display
- 3 vordere Infrarot-Abstandssensoren
- 3 Infrarot-Bodensensoren
Auf all diese Bestandteile kann mit Hilfe von STFU zugegriffen werden.


##Super Tolle Fridolin Utilities - STFU
Die Abstraktionsschicht Super Tolle Fridolin Utilities (STFU) vereinfacht den Umgang mit den Roboter “Fridolin”. 
All Bestandteile des Fridolin können mit Hilfe von STFU ohne weitere Kenntnisse über die Hardware angesteuert werden.
In dieser Dokumentation findet man Informationen über alle Klassen und Methoden, die STFU anbietet.
Zusätzlich gibt es auch Code-Beispiele die in der Arduino-IDE geöffnet werden können, nachdem man STFU eingebunden hat.


###Installation von STFU
Die [Arduino IDE](https://www.arduino.cc/en/Main/Software# "Arduino - IDE download") sollte bereits installiert sein. Um STFU verwenden zu können muss zunächst die neueste Version von [New Liquidcrystal Bibliothek](https://bitbucket.org/fmalpartida/new-liquidcrystal/downloads/ "Bitbucket - new Liquidcrystal Bibliothek") heruntergeladen werden. STFU wurde auf Basis der Version 1.5.1 implementiert. Anschließend muss die [Super Tolle Fridolin Utilities](http://smart-machines.hs-kl.de/ressourcen-des-ak/fridolin/ "Smart Machines - STFU |Sofortdownload|") heruntergeladen werden.
Nach starten von Arduino kann unter dem Menüpunkt:
```
Sketch → Bibliothek einbinden → .ZIP Bibliothek hinzufügen
```
die heruntergeladenen ZIP-Ordner ausgewählt werden. Diese sind nun automatisch in der Arduino IDE eingebunden.
Jetzt muss nur noch unter:
```
Werkzeuge → Board
```
"Arduino Nano" ausgewählt und
```
Werkzeuge → Prozessor
```
auf "ATmega328P (Old Bootloader)" gesetzt werden.

###STFU Beispiele öffnen
Nach der Installation ist unter dem Menüpunkt:
```
Datei → Beispiele → Fridolin
```
Beispielcode der STFU Bibliothek für Fridolin vorhanden.


###Hinweise zur Benutzung von STFU
- Alle Klassen befinden sich im Namespace STFU und haben diesen Präfix
- Es sollten auf Schleifen in “loop()” verzichtet werden
- Zur Nutzung des LCD-Display muss eine extra Library eingebunden werden. Diese verbraucht verhältnismäßig viel Arbeitsspeicher
- Aufgrund der Herstellung und Hardware der Fridolins können sich einzelne Fridolin-Exemplare stark beim Lesen von Sensoren und Fahrverhalten der Motoren unterscheiden