/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"

/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - LED_Button
 *@author   Die Bitschubser
 *@date     21.05.2019
 *@version  2.0
 * Fridolins LED lässt sich über die Tasten steuern
 * Der Code ist fuer Fridolin V1.3 vorgesehen
*****/



/*!
 *@remark Pins definieren und Objekte erzeugen
*/

using namespace STFU;

/*!@section Tastenleiste und LED erzeugen, sowie Pinbelegung definieren */
static Buttonbar buttonbar = Fridolin::buttonbar();
static LED led = Fridolin::led();


void setup()
{}

void loop()
{
	/*!@brief Fridolins LED leuchtet, solange der linke Taster gedrueckt ist */
	while(buttonbar.checkButtonLeft()) 
	{
		led.on();
	}
	/*!@brief Fridolins LED blinkt, solange der mittlere Taster gedrueckt ist */
	while(buttonbar.checkButtonMid()) 
	{
		led.on();
		delay(250);
		led.switchState();
		delay(250);
	}
	/*!@brief die LED beginnt zu leuchten, wenn der rechte Taster gedrueckt wurde, 
	und Fridlin wartet dann bis der linke Taster gedrueckt wird, 
	um danach die LED wieder auszuschalten */
	if(buttonbar.checkButtonRight()) 
	{
		led.on();
		buttonbar.waitForPushButtonLeft();
		led.off();
	}
	led.off();
}