/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"


/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - Testausgaben
 *@author   Die Bitschubser
 *@date     21.05.2019
 *@version  1.0
 * Fridolin kann Testausgaben machen
 * Der Code ist fuer Fridolin V1.3 vorgesehen
 * Bei V.1.4 muessen die Werte der Motoren-Pins vertauscht werden
 * (MRGeschwindigkeit = 5, MRRichtung = 3 und MLGeschwindigkeit = 9, MLRichtung = 6)
*****/


/*!
 *@remark Pins definieren und Objekte erzeugen
*/

using namespace STFU;

/*!@section Motorobjekte erzeugen und Pinbelegung definieren */
static Engine engine = Fridolin::engine();


void setup()
{
Serial.begin(9600);
}

void loop()
{ 
  /*!@brief Fridolin faehrt vorwaerts */
  engine.driveForward(255, 127);
  /*!@brief Hier wird die Geschwindigkeit ausgegeben */ 
  print("speed: ", engine.speed());
  sleepOneSecond();

  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();
}


/*!@brief Funktion zur Formatierung der Ausgabe */
void print(const char* text, int value)
{
  Serial.print(text); Serial.println(value);
}

void sleepOneSecond()
{
	delay(1000);
}
