/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"


/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - Kreis Fahren
 *@author   Die Bitschubser
 *@date     19.05.2019
 *@version  1.0
 * Fridolin kann einen Kreis fahren
 * Der Code ist fuer Fridolin V1.3 vorgesehen
 * Bei V.1.4 muessen die Werte der Motoren-Pins vertauscht werden
 * (MRGeschwindigkeit = 5, MRRichtung = 3 und MLGeschwindigkeit = 9, MLRichtung = 6)
*****/


/*!
 *@remark Pins definieren und Objekte erzeugen
*/

using namespace STFU;

/*!@section Motorobjekte erzeugen und Pinbelegung definieren */
static Engine engine = Fridolin::engine();

void setup()
{}

void loop()
{
  /*
   * Im Kreis nach rechts fahren
   * 
   *  ~>
   * ( )
   * <~
   */
  fahreRechtsKurve(Engine::MAX_SPEED);
  fahreRechtsKurve(Engine::MAX_SPEED);
  fahreRechtsKurve(Engine::MAX_SPEED);
  fahreRechtsKurve(Engine::MAX_SPEED);
}

void fahreLinksKurve(int s)
{
  /*!@brief Fridolin faehrt nach links */
  engine.turnLeft(s);
  sleepOneSecond();
}

void fahreRechtsKurve(int s)
{
  /*!@brief Fridolin faehrt nach rechts */
  engine.turnRight(s);
  sleepOneSecond();
}

void sleepOneSecond()
{
  delay(1000);
}