/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"


/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - Rechteck Fahren
 *@author   Die Bitschubser
 *@date     19.05.2019
 *@version  1.0
 * Fridolin kann ein Rechteck fahren.
 * Der Code ist fuer Fridolin V1.3 vorgesehen
 * Bei V.1.4 muessen die Werte der Motoren-Pins vertauscht werden
 * (MRGeschwindigkeit = 5, MRRichtung = 3 und MLGeschwindigkeit = 9, MLRichtung = 6)
*****/


/*!
 *@remark Pins definieren und Objekte erzeugen
*/

using namespace STFU;

/*!@section Motorobjekte erzeugen und Pinbelegung definieren */
static Engine engine = Fridolin::engine();


void setup()
{}

void loop()
{
  /*
   * Rechteck fahren
   * 
   *  ->
   * | |
   * | |
   * <-
   */
  fahreDoppelteStreckeVorwaerts(Engine::MAX_SPEED);
  fahreRechtsKurve(Engine::MAX_SPEED);

  fahreVorwaerts(Engine::MAX_SPEED);
  fahreRechtsKurve(Engine::MAX_SPEED);

  fahreDoppelteStreckeVorwaerts(Engine::MAX_SPEED);
  fahreRechtsKurve(Engine::MAX_SPEED);

  fahreVorwaerts(Engine::MAX_SPEED);
  fahreRechtsKurve(Engine::MAX_SPEED);
}

void fahreDoppelteStreckeVorwaerts(int s)
{
  fahreVorwaerts(s);
  fahreVorwaerts(s);
}

void fahreLinksKurve(int s)
{
  /*!@brief Fridolin dreht nach links */
  engine.rotateLeft(s);
  sleepOneSecond();
  
  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();
}

void fahreRechtsKurve(int s)
{
  /*!@brief Fridolin dreht nach rechts */
  engine.rotateRight(s);
  sleepOneSecond();

  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();
}

void fahreVorwaerts(int s)
{
  /*!@brief Fridolin faehrt vorwaerts */
  engine.driveForward(s);
  sleepOneSecond();

  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();
}

void sleepOneSecond()
{
  delay(1000);
}