/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"


/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - Viereck Fahren
 *@author   Die Bitschubser
 *@date     19.05.2019
 *@version  1.0
 * Fridolin kann ein Viereck fahren.
 * Der Code ist fuer Fridolin V1.3 vorgesehen
 * Bei V.1.4 muessen die Werte der Motoren-Pins vertauscht werden
 * (MRGeschwindigkeit = 5, MRRichtung = 3 und MLGeschwindigkeit = 9, MLRichtung = 6)
*****/


/*!
 *@remark Pins definieren und Objekte erzeugen
*/

using namespace STFU;

/*!@section Motorobjekte erzeugen und Pinbelegung definieren */
static Engine engine = Fridolin::engine();


void setup()
{}

void loop()
{
  /*
   * Viereck fahren
   * 
   * <-
   * | |
   *  ->
   */
  fahreVorwaerts(Engine::HALF_SPEED);
  fahreLinksKurve(Engine::HALF_SPEED);

  fahreVorwaerts(Engine::HALF_SPEED);
  fahreLinksKurve(Engine::HALF_SPEED);

  fahreVorwaerts(Engine::HALF_SPEED);
  fahreLinksKurve(Engine::HALF_SPEED);
}

void fahreLinksKurve(int s)
{
  /*!@brief Fridolin dreht auf der Stelle nach links */
  engine.rotateLeft(s);
  sleepOneSecond();

  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();
}

void fahreRechtsKurve(int s)
{
  /*!@brief Fridolin dreht auf der Stelle nach rechts */
  engine.rotateRight(s);
  sleepOneSecond();

  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();
}

void fahreVorwaerts(int s)
{
  /*!@brief Fridolin faehrt vorwaerts */
  engine.driveForward(s);
  sleepOneSecond();

  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();
}

void sleepOneSecond()
{
  delay(1000);
}