/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"


/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - Vorwaerts und Rueckwaertsfahren
 *@author   Die Bitschubser
 *@date     19.05.2019
 *@version  1.0
 * Fridolin kann vorwaerts und rueckwaertsfahren
 * Der Code ist fuer Fridolin V1.3 vorgesehen
 * Bei V.1.4 muessen die Werte der Motoren-Pins vertauscht werden
 * (MRGeschwindigkeit = 5, MRRichtung = 3 und MLGeschwindigkeit = 9, MLRichtung = 6)
*****/


/*!
 *@remark Pins definieren und Objekte erzeugen
*/

using namespace STFU;

/*!@section Motorobjekte erzeugen und Pinbelegung definieren */
static Engine engine = Fridolin::engine();


void setup()
{}

void loop()
{
  /*
   * vorwaerts fahren -> anhalten -> rueckwaerts fahren -> anhalten
   * 
   * -> | <- |
   */
  /*!@brief Fridolin faehrt vorwaerts */
  engine.driveForward(50_percent);
  sleepOneSecond();

  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();

  /*!@brief Fridolin faehrt rueckwaerts */
  engine.driveBackward(50_percent);
  sleepOneSecond();

  /*!@brief Fridolin bleibt stehen */
  engine.stop();
  sleepOneSecond();
}

void sleepOneSecond()
{
	delay(1000);
}