/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"


/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - Vorwaerts und Rueckwaertsfahren
 *@author   Die Bitschubser
 *@date     19.05.2019
 *@version  1.0
 * Fridolin kann vorwaerts und rueckwaertsfahren
 * Der Code ist fuer Fridolin V1.3 vorgesehen
 * Bei V.1.4 muessen die Werte der Motoren-Pins vertauscht werden
 * (MRGeschwindigkeit = 5, MRRichtung = 3 und MLGeschwindigkeit = 9, MLRichtung = 6)
*****/


/*!
 *@remark Pins definieren und Objekte erzeugen
*/

using namespace STFU;

/*!@section Motorobjekte erzeugen und Pinbelegung definieren */
static Engine engine = Fridolin::engine();
/*!@section Ultraschallsensorobjekt erzeugen und Pinbelegung definieren */
static UltrasonicSensor usensor = Fridolin::ultrasonicSensor();
/*!@section Abstandssensorobjekt erzeugen und Pinbelegung definieren */
static FrontSensor frontsensor = Fridolin::frontSensor();


void setup()
{
  Serial.begin(9600);
  //usensor.servo(50);
}

void loop()
{
  int abstand = ultrasensor();
  int vorne = frontsensor.midFrontDistance();
  int vornerechts = frontsensor.rightFrontDistance();
  int vornelinks = frontsensor.leftFrontDistance();

  //Serial.print("rechts: "); Serial.println(vornerechts);
  //Serial.print("links: "); Serial.println(vornelinks);
  //Serial.println(abstand);

  if (vorne <= 14 && abstand <= 25)
  {
    drehelinks();
  }

  if(vornerechts <= 15)
  {
    engine.driveForward(30_percent, 50_percent);
  }
  else if (vornelinks <= 15)
  {
    engine.driveForward(50_percent, 30_percent);
  }
  else
  {
    engine.driveForward(50_percent, 45_percent);
  }

  if(abstand >= 1 && abstand <= 35)
  {
    engine.driveForward(50_percent, 45_percent);
  }
  else if (abstand > 1)
  {
    delay(500);
    dreherechts();
    engine.driveForward(50_percent, 45_percent); 
    delay(570);
  }
}

void dreherechts()
{
  engine.rotateRight(50_percent, 0_percent);
  delay(1500);
  engine.stop();
}

void drehelinks()
{
  engine.rotateLeft(0_percent, 50_percent);
  delay(1200);
  engine.stop();
}

int ultrasensor()
{
  int test[4];
  for(int i = 0; i < 4; i++) {
    test[i] = usensor.read();
    delay(10);
  }

  bubblesort(test, 4);
  
  int mittel = test[1] + test[2];
  mittel /= 2;

  Serial.println(mittel);
  return mittel;
}

void bubblesort(int *array, int length)
{
   int i, j,tmp;

   for (i = 1; i < length ; i++) 
   {
      for (j = 0; j < length - i ; j++) 
      {
          if (array[j] > array[j+1]) 
          {
              tmp = array[j];
              array[j] = array[j+1];
              array[j+1] = tmp;
          }
      }
   }
}
