/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"


/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - Maze
 *@author   Die Bitschubser
 *@date     12.06.2019
 *@version  1.0
 * Fridolin kann ein Labyrinth durchfahren
 * Der Code ist fuer Fridolin V1.3 vorgesehen
 * Bei V.1.4 muessen die Werte der Motoren-Pins vertauscht werden
 * (MRGeschwindigkeit = 5, MRRichtung = 3 und MLGeschwindigkeit = 9, MLRichtung = 6)
*****/


/*!
 *@remark Pins definieren und Objekte erzeugen
*/

using namespace STFU;

/*!@section Motorobjekte erzeugen und Pinbelegung definieren */
static Engine engine = Fridolin::engine();
/*!@section Abstandssensorobjekt erzeugen und Pinbelegung definieren */
static FrontSensor frontsensor = Fridolin::frontSensor();


/*!@section Variablendeklaration */
/*!@brief Aktueller Wert des mittleren Frontsensors */
int vorne;
/*!@brief Aktueller Wert des rechten Frontsensors */
int vornerechts;
/*!@brief Aktueller Wert des linken Frontsensors */
int vornelinks;

void setup()
{}


void loop()
{
  /*!@brief Sensoren auslesen */
  vorne = frontsensor.midFrontDistance();
  vornerechts = frontsensor.rightFrontDistance();
  vornelinks = frontsensor.leftFrontDistance();

  /*!@brief Fridolin ist 8 cm von der Wand vor ihm und 8 cm von der Wand rechts entfernt */
  if(vorne < 8 && vornerechts < 8)
  {
    engine.driveBackward(60_percent);
    delay(50);
  }
  /*!@brief Fridolin ist mehr als 5 cm und weniger als 12 cm von der Wand rechts von ihm entfernt */
  else if(vornerechts > 5 && vornerechts < 12)
  {
    engine.rotateLeft(50_percent);
    delay(50);
  }
  /*!@brief Fridolin ist mehr als 15 cm von der Wand rechts von ihm und weniger als 10 cm von der Wand links von ihm entfernt */
  else if(vornerechts > 15 && vornelinks < 10)
  {
    engine.rotateRight(50_percent);
    delay(50);
  }
  /*!@brief Wenn keine Abstände zu den Wänden gemessen werden fährt Fridolin eine Rechtskurve um immer an der Wand zu bleiben */
  else
  {
    engine.driveForward(60_percent, 40_percent);
    delay(50);
  }
}