/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"

/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - BodenSensoren Einlesen
 *@author   Die Bitschubser
 *@date     21.05.2019
 *@version  1.0
 * Ausgabe der Werte der BodenSensoren über den serialen Monitor, sobald diese sich ändern
*****/

using namespace STFU;

/*!@section Bodensensorobjekte erzeugen und Pinbelegung definieren */
static GroundSensor groundSensor=Fridolin::groundSensor();

/*!@section Variablendeklaration */
/*!@brief Letzter Wert des linken Bodensensors */
bool groundSensorLeft = false;
/*!@brief Letzter Wert des mittleren Bodensensors */
bool groundSensorMiddle = false;
int groundSensorMiddleValue = 0;
/*!@brief Letzter Wert des rechten Bodensensors */
bool groundSensorRight = false;

void setup()
{
  Serial.begin(9600);
}

void loop()
{
  /*!@brief Bodensensoren auslesen */
  bool left=groundSensor.left();
  bool middle=groundSensor.middle();          //Digitaler Wert
  int middleValue=groundSensor.middleValue(); //Analoger Wert
  bool right=groundSensor.right();
  
  /*!@brief Bei Änderung des Werts vom linken BodenSensor Wert auf seriellem Monitor ausgeben */
  if(left != groundSensorLeft){
    groundSensorLeft=left;
    Serial.print("Links: ");
    Serial.println(groundSensorLeft);
  }
  
  /*!@brief Bei Änderung des Werts vom mittleren BodenSensor Wert auf seriellem Monitor ausgeben */
  if(middle != groundSensorMiddle){
    groundSensorMiddle=middle;
    Serial.print("Mitte (digital): ");
    Serial.println(groundSensorMiddle);
  }
  
  /*!@brief Bei Änderung des analogen Werts vom mittleren BodenSensor Wert auf seriellem Monitor ausgeben */
  if(middleValue != groundSensorMiddleValue){
    groundSensorMiddleValue=middleValue;
    Serial.print("Mitte (analog): ");
    Serial.println(groundSensorMiddleValue);
  }
  
  /*!@brief Bei Änderung des Werts vom linken BodenSensor Wert auf seriellem Monitor ausgeben */
  if(right != groundSensorRight){
    groundSensorRight=right;
    Serial.print("Rechts: ");
    Serial.println(groundSensorRight);
  }
  delay(250);
}
