/*!@brief Einbinden der Fridolin Bibliothek */
#include "Fridolin.h"

/*!
 *@mainpage Fridolin - Examples
 *@section  Fridolin - Abstandssensor
 *@author   Die Bitschubser - Felix Mayer
 *@date     02.06.2019
 *@version  1.0
 * Fridolin fährt vorwärts bis er auf ein Hindernis stößt, und fährt zurück, wenn es für ihm zu nah ist
 * Der Code ist fuer Fridolin V1.3 vorgesehen
*****/

using namespace STFU;

/*!
 *@remark Pins definieren und Objekte erzeugen
*/
/*!@section Abstandssensorobjekt erzeugen und Pinbelegung definieren */
static FrontSensor frontSensor = Fridolin::frontSensor();

/*@brief Abstand festegen */
int mindestAbstand=5;
int maximalAbstand=8;

/*!@section Motorobjekte erzeugen und Pinbelegung definieren */
static Engine engine = Fridolin::engine();

void setup()
{
  Serial.begin(9600);
}

void loop()
{
  /*!@brief Fridolin fährt näher, wenn er zu weit weg von einer Wand ist, solange die Wand in sichtweite ist*/
  Serial.println(frontSensor.midFrontDistance());
  if ((frontSensor.midFrontDistance()>maximalAbstand)&&(frontSensor.midFrontDistance()<25))
  {
    Serial.println("zu weit weg");
    engine.driveForward(40_percent);
  }
  /*!@brief Fridolin fährt zurück, wenn er zu nah an einer Wand ist*/
  if (frontSensor.midFrontDistance()<mindestAbstand)
  {
    Serial.println("zu nah");
    engine.driveBackward(40_percent);
  }
  /*!@brief Fridolin bleibt stehen, wenn er die passende Distanz zur Wand hat*/
  if ((frontSensor.midFrontDistance()>mindestAbstand)&&(frontSensor.midFrontDistance()<maximalAbstand))
  {
    Serial.println("passt");
    engine.stop();
  }
  sleep(250);
}

void sleep(int miliSeconds)
{
  delay(miliSeconds);
}
