#pragma once

#include "Arduino.h"


/*!
 * @author Die Bitschubser
 * @date 21.05.2019
 * @file Button.h
 * @version 1.1
 * @brief Enthaelt die Klasse Button
 *****/

namespace STFU
{
/*!
 * @class Button Button.h
 * @brief Diese Klasse stellt die Initialisierung und Funktionen für den Taster bereit
 *****/
class Button
{
public:
  /*!
   * @brief Der Defaultkonstruktor ist verboten
   */
  Button() = delete;
  /*!
   * @brief Button
   * @param[in] int  Stellt den angepeilten PIN für den Taste dar
   */
  Button(int);
  /*!
   * @brief Das System pausiert bis der Taster gedrueckt wurde
   */
  void waitForPushButton() const;
  /*!
   * @brief Abfrage des Status von dem Taster
   * @return Liefert true, wenn der Taster gedrueckt ist, sonst false
   */
  bool checkButton() const;

private:
  /*! @brief Der Taster Pin */
  const int _buttonPin;
};

}