#include "Buttonbar.h"


namespace STFU
{

Buttonbar::Buttonbar(int leftButtonPin, int midButtonPin, int rightButtonPin)
{
  static Button left{leftButtonPin};
  static Button mid{midButtonPin};
  static Button right{rightButtonPin};
  _leftButton=&left;
  _midButton=&mid;
  _rightButton=&right;
}

Buttonbar::~Buttonbar()
{
  _leftButton = nullptr;
  _midButton = nullptr;
  _rightButton = nullptr;
}


void Buttonbar::waitForPushButtonLeft() const
{
  _leftButton->waitForPushButton();
}

void Buttonbar::waitForPushButtonMid() const
{
  _midButton->waitForPushButton();
}

void Buttonbar::waitForPushButtonRight() const
{
  _rightButton->waitForPushButton();
}

bool Buttonbar::checkButtonLeft() const
{
  return _leftButton->checkButton();
}

bool Buttonbar::checkButtonMid() const
{
  return _midButton->checkButton();
}

bool Buttonbar::checkButtonRight() const
{
  return _rightButton->checkButton();
}


const Button& Buttonbar::leftButton() const
{
  return (*_leftButton);
}

const Button& Buttonbar::midButton() const
{
  return (*_midButton);
}

const Button& Buttonbar::rightButton() const
{
  return (*_rightButton);
}

}