#include "Display.h"

namespace STFU
{
/*! Display */
Display::Display(uint8_t lcd_Addr, uint8_t En, uint8_t Rw, uint8_t Rs,
                 uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7,
                 uint8_t background)
{
  _LCD = new LiquidCrystal_I2C{lcd_Addr, En, Rw, Rs, d4, d5, d6, d7};
  _LCD->setBacklightPin(background, POSITIVE);
  _LCD->setBacklight(LOW);
}

/*! DESTRUKTOR */
Display::~Display()
{
  delete _LCD;
  _LCD = nullptr;
}

/*! MEMBER */
void Display::textRowOne(String text)
{
  _LCD->setCursor(0,0);
  _LCD->print(text.c_str());
}

void Display::textRowTwo(String text)
{
  _LCD->setCursor(0,1);
  _LCD->print(text.c_str());
}

void Display::textInBothRows(String textrowone, String textrowtwo) 
{
  _LCD->setCursor(0,0);
  _LCD->print(textrowone.c_str());
  _LCD->setCursor(0,1);
  _LCD->print(textrowtwo.c_str());
}

void Display::clear() 
{
  _LCD->clear();
}

void Display::setup()
{
  _LCD->begin(16,2);
}

}