#pragma once

#include "Arduino.h"


/*!
 * @author Die Bitschubser
 * @date 21.05.2019
 * @file LED.h
 * @version 3.0
 * @brief Enthaelt die Klasse LED
 *****/
 
 namespace STFU
{
 /*!
  * @class LED LED.h
  * @brief Klasse fuer die LED
  *****/
class LED
{
public:
  /*!
   * @brief Der Defaultkonstruktor ist verboten
   */
  LED() = delete;
  /*!
  * @brief Konstruktor mit Pinbelegung der LED
  * @param[in] int  PIN fuer die LED
  */
  LED(int);
  /*!
  * @brief Schaltet die LED Lampe an
  */
  void on();
  /*!
  * @brief Schaltet die LED Lampe aus
  */
  void off();
  /*!
  * @brief Schaltet die LED Lampe an, falls sie aus war oder schaltet die LED Lampe aus falls sie an war
  */
  void switchState();
  /*!
  * @brief Abfrage des Status der LED Lampe
  * @return Gibt true für eine angeschaltete LED zurück unf false für eine ausgeschaltete
  */
  bool state() const;
private:
  /*! @brief genutzter PIN der LED */
  const int _pin;
};

}