#include "FrontSensor.h"

namespace STFU
{

FrontSensor::FrontSensor(int leftPin, int midPin, int rightPin)
{
  static InfraredSensor left{ leftPin };
  static InfraredSensor mid{ midPin };
  static InfraredSensor right{ rightPin };
  _leftIR = &left;
  _midIR = &mid;
  _rightIR = &right;
}

FrontSensor::~FrontSensor()
{
  _leftIR = nullptr;
  _midIR = nullptr;
  _rightIR = nullptr;
}


int FrontSensor::leftFrontDistance() const
{
  return _leftIR->distance();
}
int FrontSensor::midFrontDistance() const
{
  return _midIR->distance();
}
int FrontSensor::rightFrontDistance() const
{
  return _rightIR->distance();
}


int FrontSensor::leftValue() const
{
  return _leftIR->read();
}

int FrontSensor::midValue() const
{
  return _midIR->read();
}

int FrontSensor::rightValue() const
{
  return _rightIR->read();
}

}