#include "GroundSensor.h"


namespace STFU
{

GroundSensor::GroundSensor(DigitalSensor& left, DigitalSensor& right, AnalogSensor& middle) 
	: _left(&left),
	  _right(&right),
	  _middle(&middle)
{
	
}

bool GroundSensor::left() const {
	return _left->read();
}

bool GroundSensor::right() const {
	return _right->read();
}

bool GroundSensor::middle() const {
	return middleValue() > m_threshold;
}

int GroundSensor::middleValue() const {
	return convert(_middle->read());
}

void GroundSensor::threshold(int t) {
	if(t > MAX_BRIGHTNESS) {
		m_threshold = MAX_BRIGHTNESS;
	}
	else if(t < MIN_BRIGHTNESS) {
		m_threshold = MIN_BRIGHTNESS;
	}
	else {
		m_threshold = t;
	}
}

int GroundSensor::threshold() const {
	return m_threshold;
}

int GroundSensor::convert(int value) const {
	
	return map(value, AnalogSensor::MIN_VALUE, AnalogSensor::MAX_VALUE, MIN_BRIGHTNESS, MAX_BRIGHTNESS);
}

}