#include "Sensor.h"

namespace STFU
{

Sensor::Sensor(int p) : _pin(p)
{
  pinMode(_pin, INPUT);
}



DigitalSensor::DigitalSensor(int p) : Sensor(p)
{}

bool DigitalSensor::read() const
{
  return digitalRead(_pin);
}



AnalogSensor::AnalogSensor(int p) : Sensor(p)
{}

int AnalogSensor::read() const
{
  return analogRead(_pin);
}



InfraredSensor::InfraredSensor(int p) : AnalogSensor(p)
{}

int InfraredSensor::distance() const
{
  float volts = read() * 0.0048828125; // 5 / 1024
  int distance = 13 * pow(volts, -1);
  return distance;
}

}