#include "UltrasonicSensor.h"

namespace STFU
{

UltrasonicSensor::UltrasonicSensor(int servo,int trigger,int echo) : _servopin(servo),_triggerpin(trigger),_echopin(echo) {
  pinMode(_triggerpin, OUTPUT);
  pinMode(_echopin, INPUT);
  digitalWrite(_triggerpin, HIGH);
}

int UltrasonicSensor::read() const
{
  digitalWrite(_triggerpin, LOW);
  delayMicroseconds(2);
  digitalWrite(_triggerpin, HIGH);
  delayMicroseconds(10);
  digitalWrite(_triggerpin, LOW);
  int dauer = pulseIn(_echopin, HIGH);
  int distance = (dauer/2)/29.1;

  return (distance < 0 ? 1 : distance);
  //digitalWrite(_triggerpin, LOW);
  //int dauer = pulseIn(_echopin, HIGH);
  //digitalWrite(_triggerpin, HIGH);
  //return dauer;
}

int UltrasonicSensor::read(int degree) {
  int wait=servo(degree);
  delay(wait);
  return read();
}

bool UltrasonicSensor::readDigital() const
{
  return read()<30;
}

bool UltrasonicSensor::readDigital(int degree) {
  int wait=servo(degree);
  delay(wait);
  return readDigital();
}

int UltrasonicSensor::servo(int degree) {
  if(!_servo.attached()){
    _servo.attach(_servopin);
  }
  if(degree < MIN_SERVO_DEGREE) {
    degree=MIN_SERVO_DEGREE;
  } else if(degree > MAX_SERVO_DEGREE) {
    degree=MAX_SERVO_DEGREE;
  }
  if((_degreeServo-degree) > 90) {
    servo(90);
  }
  if(_degreeMiddle!=90||_degreeRight!=180){
    degree=map(degree,MIN_SERVO_DEGREE,MAX_SERVO_DEGREE,_degreeRight-2*(_degreeRight-_degreeMiddle),_degreeRight);
    if(degree < MIN_SERVO_DEGREE) {
      degree=MIN_SERVO_DEGREE;
    } else if(degree > MAX_SERVO_DEGREE) {
      degree=MAX_SERVO_DEGREE;
    }
  }
  _servo.write(degree);
  Serial.print("");
  int wait=(double)(_degreeServo-degree)*500/180;
  if(wait<0) wait*=-1;
  _degreeServo=degree;
  return wait;
}

int UltrasonicSensor::servo() const {
  return _degreeServo;
}

void UltrasonicSensor::setup(int degree_middle,int degree_right) {
  _degreeMiddle=degree_middle;
  _degreeRight=degree_right;
}

}